## diskscan 0.13

=== Makefile ===
all:
	./do all

static:
	LDFLAGS=-static ./do all

scan:
	scan-build ./do all

clean:
	./do clean

install:
	./do all install

distclean:
	./do clean

=== debian/changelog ===
diskscan (0.13-1) unstable; urgency=low

  * Initial release (Closes: #724458)

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Mon, 07 Oct 2013 06:47:01 -0300

=== debian/control ===
Source: diskscan
Section: utils
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>
Build-Depends: debhelper (>= 9), python-beautifulsoup, python-markdown
Standards-Version: 3.9.4
Homepage: https://github.com/baruch/diskscan
Vcs-Git: git://anonscm.debian.org/collab-maint/diskscan.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/diskscan.git;a=summary

Package: diskscan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: f3
Description: scan HDD/SSD for bad or near failure sectors
 diskscan is intended to check a disk (hard disk, flash drive, pendrive etc)
 and find any bad sectors already present and assess it for any possible
 sectors that are in the process of going bad.
 .
 The operation is all read-only and doesn't causes damage to the data on the
 disk. As the program reads block device sectors it will work whether there
 is a filesystem or not.
 .
 diskscan reads the entire block device and notes the time it took to read a
 block. When there is an error it is immediately noted and also when there is
 a higher latency to read a block. A histogram of the block latency times is
 also given to assess the health of the disk.
 .
 diskscan also can be used to test the speed and quality of the removable /
 solid / portable medias, as flash drives. A good media will have all yours
 sectors read in the same speed.

=== debian/watch ===
version=3
https://github.com/baruch/diskscan /tree/(?:diskscan-)?(\d+.*)

## diskscan 0.14.1

=== debian/control ===
Source: diskscan
Section: utils
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, automake, python-beautifulsoup,
               python-markdown, python-yaml
Standards-Version: 3.9.6
Homepage: https://github.com/baruch/diskscan
Vcs-Git: git://anonscm.debian.org/collab-maint/diskscan.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/diskscan.git

Package: diskscan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: f3
Description: scan storage media for bad or near failure sectors
 diskscan is intended to find sectors of a storage medium
 (hard disk, flash drive or pendrive, etc.) which are bad
 or in the process of going bad.
 .
 The operation is entirely read-only and does not cause
 damage to the data on filesystems. As the program reads
 block device sectors, it will work whether there is a
 filesystem or not.
 .
 diskscan reads the entire block device and notes the time
 it took to read a block. When there is an error it is
 immediately noted and also when there is a higher latency
 to read a block. A histogram of the block latency times is
 also given to assess the health of the medium.
 .
 diskscan can also be used to test the speed and quality of
 the medium. All sectors of a perfect medium could be read
 at the same speed.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_CFLAGS_MAINT_APPEND  = -fPIE
export DEB_LDFLAGS_MAINT_APPEND = -fPIE -Wl,-z,now

%:
	dh $@ --parallel --with autotools-dev

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure

override_dh_installchangelogs:
	dh_installchangelogs debian/upstream.changelog

## diskscan 0.16

=== Makefile ===
# Adapter for those who don't know ninja

DESTDIR ?= 
PREFIX ?= /usr/local

all: build

build.ninja: configure
	./configure
	@if [ "${V}" = 1]; then \
		echo 'build.binja'; cat build.ninja; \
		echo 'lib.ninja'; cat libscsicmd/lib.ninja; \
	fi


build: build.ninja
	@if [ "${V}" = 1 ]; then ninja -v; else ninja; fi

clean:
	ninja -t clean

install: diskscan Documentation/diskscan.1
	install -m 0755 diskscan $(DESTDIR)$(PREFIX)/bin/diskscan
	install -m 0444 Documentation/diskscan.1 $(DESTDIR)$(PREFIX)/man/man1/diskscan.1

.PHONY: all clean build install

# TODO: Port the scan to ninja
#scan:
#	scan-build ./do all

# Recreate targets: dist distclean

=== debian/changelog ===
diskscan (0.16-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 02 Nov 2015 18:30:56 -0200

diskscan (0.16-1) unstable; urgency=medium

  * New upstream release.
  * The upstream is using a new method to build the final files. Consequently:
      - Dropped the dh-autoreconf.
      - debian/clean: updated to use a new content.
      - debian/control: added ctags and ninja-build to Build-Depends field.
      - debian/dirs: added to create some necessary directories.
      - debian/patches/:
          ~ Removed the useless Makefile patch.
          ~ Added the fix-manpage-path patch to fix the manpage install place.
          ~ Added the fix-make-clean patch to avoid a FTBFS in first build.
      - debian/rules:
          ~ Full updated and adapted.
          ~ Added V=1 variable to force to show the commands when compiling.
          ~ Using DEB_BUILD_MAINT_OPTIONS variable, instead of
            DEB_CFLAGS_MAINT_APPEND and DEB_LDFLAGS_MAINT_APPEND to improve the
            GCC hardening.
      - debian/source/options: added to ignore changes in specific files.
  * debian/copyright: full updated.
  * debian/docs: added to install the upstream README.md file.
  * debian/gbp.conf: not used by me... Removed.
  * Leaving of provide a picked upstream changelog. Consequently:
     - Removed the debian/README.source file.
     - Removed the debian/upstream.changelog file.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 04 Oct 2015 01:25:36 -0300

diskscan (0.15-1) unstable; urgency=medium

  * New upstream release. (Closes: #782733)
  * Using autoreconf now.
  * debian/clean: updated.
  * debian/copyright:
      - Added new copyright notices.
      - Removed the dot-zero from GPL licenses.
      - Updated the upstream and packaging copyright years.
  * debian/upstream.changelog: updated.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 20 May 2015 20:10:06 -0300

diskscan (0.14.1-6) unstable; urgency=medium

  * Bumped Standards-Version to 3.9.6.
  * debian/copyright: removed the space in 'public domain'
      license name.
  * debian/rules: added the DEB_CFLAGS_MAINT_APPEND and
      DEB_LDFLAGS_MAINT_APPEND variables to fix some
      issues pointed by blhc.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 26 Oct 2014 19:01:33 -0200

diskscan (0.14.1-5) unstable; urgency=medium

  * New maintainer email address.
  * debian/control: updated the Vcs-Browser field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 03 Aug 2014 12:33:50 -0300

diskscan (0.14.1-4) unstable; urgency=medium

  * debian/control: new improvement to the short and long description. Thanks
    again to Filipus Klutiero <chealer@gmail.com>. (Closes: #749681)

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Sun, 01 Jun 2014 01:15:45 -0300

diskscan (0.14.1-3) unstable; urgency=medium

  * debian/control: improved the long description.  Thanks to
    Filipus Klutiero <chealer@gmail.com>. (Closes: #749197)

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Sun, 25 May 2014 12:02:34 -0300

diskscan (0.14.1-2) unstable; urgency=medium

  * Added the Makefile patch that forces the verbose mode to
    show flags when compiling.

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Fri, 23 May 2014 07:50:32 -0300

diskscan (0.14.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/clean: added to remove some forgotten files.
  * debian/control:
      - Added autotools-dev, automake, python-yaml as build dependency.
      - Updated Standards-Version from 3.9.4 to 3.9.5.
  * debian/copyright: updated the upstream and packaging copyright years.
  * debian/rules:
      - Added the autotools-dev option to main target.
      - Added the override_dh_auto_configure target to execute the
        autogen.sh upstream script.
      - Removed unneeded lines to provide GCC hardening.
  * debian/upstream.changelog: updated.
  * debian/watch: fixed the download and improved the regexp.

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Tue, 20 May 2014 21:35:00 -0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,12 @@
 Section: utils
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper (>= 9), autotools-dev, automake, python-beautifulsoup,
-               python-markdown, python-yaml
+Build-Depends: debhelper (>= 9),
+               ctags,
+               ninja-build,
+               python-beautifulsoup,
+               python-markdown,
+               python-yaml
 Standards-Version: 3.9.6
 Homepage: https://github.com/baruch/diskscan
 Vcs-Git: git://anonscm.debian.org/collab-maint/diskscan.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export V=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

## diskscan 0.17

=== Makefile ===
# Adapter for those who don't know ninja

DESTDIR ?= 
PREFIX ?= /usr/local

all: build

build.ninja: configure
	./configure
	@if [ "${V}" = 1 ]; then \
		echo 'build.binja'; cat build.ninja; \
		echo 'lib.ninja'; cat libscsicmd/lib.ninja; \
	fi


build: build.ninja
	@if [ "${V}" = 1 ]; then ninja -v; else ninja; fi

clean:
	if [ -e build.ninja ]; then ninja -t clean; fi

distclean:
	-rm -rf build.ninja .ninja_deps .ninja_log libscsicmd/*.ninja libscsicmd/build/*.pyc

install: diskscan Documentation/diskscan.1
	install -m 0755 diskscan $(DESTDIR)$(PREFIX)/bin/diskscan
	install -m 0444 Documentation/diskscan.1 $(DESTDIR)$(PREFIX)/share/man/man1/diskscan.1

.PHONY: all clean distclean build install update-libscsicmd buildtest

buildtest:
	./configure
	ninja
	ninja -t clean
	
	./configure --dev
	ninja
	ninja -t clean
	
	CC="clang-3.8" ./configure --dev
	ninja
	ninja -t clean

# TODO: Port the scan to ninja
#scan:
#	scan-build ./do all

# Recreate targets: dist distclean

update-libscsicmd:
	git subtree pull --squash --prefix libscsicmd https://github.com/baruch/libscsicmd master

update-progressbar:
	git subtree pull --squash --prefix progressbar https://github.com/doches/progressbar master

update-hdrhistogram:
	git subtree pull --squash --prefix hdrhistogram https://github.com/HdrHistogram/HdrHistogram_c master

=== libscsicmd/Makefile ===
# Adapter for those who don't know ninja
all:
	ninja

clean:
	ninja -t clean

.PHONY: all clean

=== debian/changelog ===
diskscan (0.17-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 08 Nov 2015 17:27:53 -0200

diskscan (0.17-1) unstable; urgency=medium

  * New upstream release. (Closes: #803794)
  * debian/clean: removed previous names and added new entries to remove
      some files forgotten by upstream when cleaning the source code.
  * debian/control: added libncurses5-dev and zlib1g-dev to Build-Depends
      field.
  * debian/copyright: updated some information about the upstream.
  * debian/patches: removed. The upstream fixed the source code. Thanks.
  * debian/rules:
      - Added the target override_dh_auto_clean to remove the directory
        'built', forgotten by upstream.
      - Added the target override_dh_auto_configure to run a single
        'configure' command.
  * debian/source/options: removed. The upstream fixed the source code.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 02 Nov 2015 18:37:45 -0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,12 @@
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper (>= 9),
                ctags,
+               libncurses5-dev,
                ninja-build,
                python-beautifulsoup,
                python-markdown,
-               python-yaml
+               python-yaml,
+               zlib1g-dev
 Standards-Version: 3.9.6
 Homepage: https://github.com/baruch/diskscan
 Vcs-Git: git://anonscm.debian.org/collab-maint/diskscan.git

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,12 @@
 %:
 	dh $@
 
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -rf built
+
+override_dh_auto_configure:
+	./configure
+
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr

## diskscan 0.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(diskscan
        VERSION 0.18)

export(PACKAGE diskscan)

set(PACKAGE_VERSION ${PROJECT_VERSION})

# Pull in zlib
find_package(ZLIB REQUIRED)

# Ensure clock_gettime can build with or without -lrt as needed
include(CheckLibraryExists)
CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
if (NOT HAVE_CLOCK_GETTIME)
   set(CMAKE_EXTRA_INCLUDE_FILES time.h)
   CHECK_FUNCTION_EXISTS(clock_gettime HAVE_CLOCK_GETTIME)
   SET(CMAKE_EXTRA_INCLUDE_FILES)
else()
        list(APPEND LIBS rt)
endif()

# Find tinfo for termcap functions
find_library(tinfo_LIBRARY NAMES tinfo curses)

# Architecture files
if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        set(ARCH_SRC "arch/arch-linux.c")
        set(ARCH_INCLUDE "arch/arch-linux.h")
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
        set(ARCH_SRC "arch/arch-freebsd.c")
        set(ARCH_INCLUDE "arch/arch-posix.h")
else()
        set(ARCH_SRC "arch/arch-posix.c")
        set(ARCH_INCLUDE "arch/arch-posix.h")
endif()

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/include/arch-internal.h
        COMMAND ln -fs ${CMAKE_CURRENT_SOURCE_DIR}/${ARCH_INCLUDE} ${CMAKE_CURRENT_SOURCE_DIR}/include/arch-internal.h
                  )

# Build diskscan
include_directories("include")
add_compile_options(-Wall -Wextra -Wshadow -Wmissing-prototypes -Winit-self)
add_definitions(-D_GNU_SOURCE -D_FORTIFY_SOURCE=2)
add_definitions(-DVERSION="${PROJECT_VERSION}")
include_directories(.)
include_directories(progressbar/include)

# Build libscsicmd for diskscan
include_directories(libscsicmd/include)
add_subdirectory(libscsicmd/src)

# Build diskscan library
add_library(diskscanlib STATIC lib/data.c lib/diskscan.c lib/sha1.c lib/system_id.c lib/verbose.c lib/disk.c
        hdrhistogram/src/hdr_histogram.c hdrhistogram/src/hdr_histogram_log.c
        hdrhistogram/src/hdr_encoding.c ${ARCH_SRC} ${CMAKE_CURRENT_SOURCE_DIR}/include/arch-internal.h)
add_dependencies(diskscanlib scsicmd)

# Build diskscan cli command
add_executable(diskscan diskscan.c cli/cli.c cli/verbose.c progressbar/lib/progressbar.c)
target_link_libraries(diskscan diskscanlib scsicmd m ${tinfo_LIBRARY} ${ZLIB_LIBRARIES} ${LIBS})

install(TARGETS diskscan
        RUNTIME DESTINATION bin)

configure_file(Documentation/diskscan.1.in Documentation/diskscan.1)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Documentation/diskscan.1
        DESTINATION share/man/man1 COMPONENT doc)

## diskscan 0.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,15 @@
 cmake_minimum_required(VERSION 3.0.2)
 project(diskscan
-        VERSION 0.18)
+        VERSION 0.19)
 
 export(PACKAGE diskscan)
 
 set(PACKAGE_VERSION ${PROJECT_VERSION})
+
+# Default to a debug build
+if(NOT CMAKE_BUILD_TYPE)
+        set(CMAKE_BUILD_TYPE Debug)
+endif(NOT CMAKE_BUILD_TYPE)
 
 # Pull in zlib
 find_package(ZLIB REQUIRED)
@@ -24,14 +29,18 @@
 find_library(tinfo_LIBRARY NAMES tinfo curses)
 
 # Architecture files
+message("SYSTEM NAME: ${CMAKE_SYSTEM_NAME}")
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
         set(ARCH_SRC "arch/arch-linux.c")
         set(ARCH_INCLUDE "arch/arch-linux.h")
+elseif (${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD")
+        set(ARCH_SRC "arch/arch-freebsd.c")
+        set(ARCH_INCLUDE "arch/arch-posix.h")
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
         set(ARCH_SRC "arch/arch-freebsd.c")
         set(ARCH_INCLUDE "arch/arch-posix.h")
 else()
-        set(ARCH_SRC "arch/arch-posix.c")
+        set(ARCH_SRC "arch/arch-generic.c")
         set(ARCH_INCLUDE "arch/arch-posix.h")
 endif()

=== libscsicmd/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libscsicmd)

export(PACKAGE libscsicmd)

include_directories("include")
add_compile_options(-Wall -Wextra -Wshadow -Wmissing-prototypes -Winit-self)
add_definitions(-D_GNU_SOURCE -D_FORTIFY_SOURCE=2)

add_subdirectory(src)
add_subdirectory(test)

=== libscsicmd/src/CMakeLists.txt ===
add_library(scsicmd STATIC ata.c ata_smart.c cdb.c parse_inquiry.c parse_read_cap.c parse_sense.c str_map.c smartdb/smartdb.c smartdb/smartdb_gen.c)

=== libscsicmd/test/CMakeLists.txt ===
add_library(testlib STATIC main.c sense_dump.c)

add_executable(ata_check_power_mode ata_check_power_mode.c)
target_link_libraries(ata_check_power_mode testlib scsicmd)

add_custom_command(OUTPUT ata_identify_dump.h
                   COMMAND ../structs/ata_struct_2_h_dump.py ../structs/ata_identify.yaml > ata_identify_dump.h
                   DEPENDS ../structs/ata_struct_2_h_dump.py ../structs/ata_identify.yaml)
add_custom_command(OUTPUT ata_identify_dump.c
                   COMMAND ../structs/ata_struct_2_c_dump.py ../structs/ata_identify.yaml > ata_identify_dump.c
                   DEPENDS ../structs/ata_struct_2_c_dump.py ../structs/ata_identify.yaml)
add_executable(ata_identify ata_identify.c ata_identify_dump.c ata_identify_dump.h)
target_link_libraries(ata_identify testlib scsicmd)

add_executable(ata_smart_read_data ata_smart_read_data.c)
target_link_libraries(ata_smart_read_data testlib scsicmd)

add_executable(ata_smart_return_status ata_smart_return_status.c)
target_link_libraries(ata_smart_return_status testlib scsicmd)

add_executable(scsi_inquiry scsi_inquiry.c)
target_link_libraries(scsi_inquiry testlib scsicmd)

add_executable(scsi_log_sense scsi_log_sense.c)
target_link_libraries(scsi_log_sense testlib scsicmd)

add_executable(scsi_read_capacity_10 scsi_read_capacity_10.c)
target_link_libraries(scsi_read_capacity_10 testlib scsicmd)

add_executable(scsi_read_capacity_16 scsi_read_capacity_16.c)
target_link_libraries(scsi_read_capacity_16 testlib scsicmd)

add_executable(sense_decode sense_decode.c)
target_link_libraries(sense_decode testlib scsicmd)

=== debian/changelog ===
diskscan (0.19-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:40:27 +0000

diskscan (0.19-1) unstable; urgency=medium

  * New upstream release.
  * The upstream adopted the debian/distclean.sh script. Consequently:
      - debian/clean: added to remove an additional 'distclean' file
        created by debhelper.
      - debian/copyright: updated the information about the distclean
        file
      - debian/distclean.sh: removed.
      - debian/rules: change the override_dh_clean to use the upstream
        distclean.sh file.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 24 Nov 2015 19:29:20 -0200

diskscan (0.18-1) unstable; urgency=medium

  * New upstream release.
  * Upstream using CMake now.
  * debian/clean: removed. Using debian/distclean.sh.
  * debian/control:
      - Added cmake to Build-Depends field.
      - Removed ctags, ninja-build, python-beautifulsoup and python-markdown
        from Build-Depends field.
  * debian/copyright: updated an information about the packaging.
  * debian/dirs: not useful now. Removed.
  * debian/distclean.sh: added to remove some files forgotten by upstream
      after the build process.
  * debian/rules:
      - Added the override_dh_clean target to call the debian/distclean.sh
        script.
      - Removed the override_dh_auto_clean, override_dh_auto_clean and
        override_dh_auto_install targets.
      - Removed the 'V' variable (unneeded now).

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 14 Nov 2015 08:29:16 -0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,8 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: debhelper (>= 9),
-               ctags,
+               cmake,
                libncurses5-dev,
-               ninja-build,
-               python-beautifulsoup,
-               python-markdown,
                python-yaml,
                zlib1g-dev
 Standards-Version: 3.9.6

=== debian/watch ===
version=3
https://github.com/baruch/diskscan/releases .*/(?:diskscan-)?(\d\S+)\.tar\.(?:bz2|gz|xz)

## diskscan 0.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,8 @@
 endif()
 
 # Find tinfo for termcap functions
+INCLUDE (CheckIncludeFiles)
+CHECK_INCLUDE_FILES(termcap.h HAVE_TERMCAP_H)
 find_library(tinfo_LIBRARY NAMES tinfo curses)
 
 # Architecture files

=== hdrhistogram/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if("${CMAKE_VERSION}" VERSION_GREATER 3.0.0)
    cmake_policy(SET CMP0042 NEW)
endif()

project("hdr_histogram")

ENABLE_TESTING()

if(UNIX)
    set(CMAKE_C_FLAGS "-Wall -Wno-unknown-pragmas -Wextra -Wshadow -Winit-self -Wmissing-prototypes -D_GNU_SOURCE")
    set(CMAKE_C_FLAGS_DEBUG "-O0 -g")
    set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
endif()

include_directories("${CMAKE_SOURCE_DIR}/src")
add_subdirectory("${CMAKE_SOURCE_DIR}/src")
add_subdirectory("${CMAKE_SOURCE_DIR}/test")
add_subdirectory("${CMAKE_SOURCE_DIR}/examples")

SET(CPACK_GENERATOR "TGZ")
SET(CPACK_PACKAGE_VERSION "0.9.1")

INCLUDE(CPack)

=== libscsicmd/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libscsicmd)

export(PACKAGE libscsicmd)

include_directories("include")
add_compile_options(-Wall -Wextra -Wshadow -Wmissing-prototypes -Winit-self -g)
add_definitions(-D_GNU_SOURCE -D_FORTIFY_SOURCE=2)

set(CMAKE_C_FLAGS_DEBUG "-Werror -O0 ${CMAKE_C_FLAGS_DEBUG}")
set(CMAKE_C_FLAGS_RELEASE "-Wall -O3 ${CMAKE_C_FLAGS_RELEASE}")

add_subdirectory(src)
add_subdirectory(test)

=== hdrhistogram/src/CMakeLists.txt ===
FILE(GLOB histogram_files "*.c")

add_library(hdr_histogram SHARED ${histogram_files})
add_library(hdr_histogram_static STATIC ${histogram_files})

target_link_libraries(hdr_histogram m z)
target_link_libraries(hdr_histogram_static m z)

install(TARGETS hdr_histogram DESTINATION lib)
install(TARGETS hdr_histogram_static DESTINATION lib)
install(FILES hdr_histogram.h hdr_histogram_log.h hdr_writer_reader_phaser.h hdr_interval_recorder.h DESTINATION include/hdr)

=== hdrhistogram/test/CMakeLists.txt ===
INCLUDE(CheckLibraryExists)

add_executable(hdr_histogram_test hdr_histogram_test.c)
add_executable(hdr_histogram_log_test hdr_histogram_log_test.c)

add_executable(perftest hdr_histogram_perf.c)

target_link_libraries(hdr_histogram_test hdr_histogram m)
target_link_libraries(hdr_histogram_log_test hdr_histogram m z)
target_link_libraries(perftest hdr_histogram m z)

CHECK_LIBRARY_EXISTS(rt clock_gettime "" RT_EXISTS)
if (RT_EXISTS)
    target_link_libraries(hdr_histogram_log_test rt)
    target_link_libraries(perftest rt)
endif (RT_EXISTS)

install(TARGETS hdr_histogram_test DESTINATION bin)
install(TARGETS hdr_histogram_log_test DESTINATION bin)
install(TARGETS perftest DESTINATION bin)

add_test(Histogram hdr_histogram_test)
add_test(HistogramLogging hdr_histogram_log_test)

configure_file(jHiccup-2.0.1.logV0.hlog jHiccup-2.0.1.logV0.hlog COPYONLY)
configure_file(jHiccup-2.0.6.logV1.hlog jHiccup-2.0.6.logV1.hlog COPYONLY)
configure_file(jHiccup-2.0.7S.logV2.hlog jHiccup-2.0.7S.logV2.hlog COPYONLY)

=== libscsicmd/src/CMakeLists.txt ===
add_library(scsicmd STATIC ata.c ata_smart.c cdb.c parse_inquiry.c parse_read_cap.c parse_sense.c log_sense.c parse.c str_map.c smartdb/smartdb.c smartdb/smartdb_gen.c)

=== debian/changelog ===
diskscan (0.20-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Refer to common license file for CC0-1.0.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Kyle Robbertze ]
  * Bump standards-version to 4.6.1 (no change)
  * d/copyright: use correct name in licence field

 -- Kyle Robbertze <paddatrapper@debian.org>  Wed, 13 Jul 2022 20:18:12 +0200

diskscan (0.20-2) unstable; urgency=medium

  * Move from python to python3 (Closes: #942985)
  * Move packaging to salsa
  * Move to debhelper-compat 12
  * Bump Standards-Version to 4.4.1 (no change)

 -- Kyle Robbertze <paddatrapper@debian.org>  Wed, 23 Oct 2019 12:32:36 +0200

diskscan (0.20-1) unstable; urgency=medium

  * New upstream version 0.20
  * debian/control:
      - Bumped Standards-Version to 4.1.1
      - Moved packaging VCS to gitlab until Alioth replacement is
        available

 -- Kyle Robbertze <krobbertze@gmail.com>  Sun, 01 Oct 2017 12:05:45 +0200

diskscan (0.19-4) unstable; urgency=medium

  * New maintainer (Closes: #848676)
  * debian/watch: corrected options so that it works

 -- Kyle Robbertze <krobbertze@gmail.com>  Mon, 09 Jan 2017 16:08:14 +0200

diskscan (0.19-3) unstable; urgency=medium

  * QA upload.
  * Set Debian QA Group as maintainer. (see #848676).

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 20 Dec 2016 07:37:25 -0200

diskscan (0.19-2) unstable; urgency=medium

  * Bumped DH level to 10.
  * debian/control:
      - Bumped Standards-Version to 3.9.8.
      - Updated the Vcs-* fields to use https instead of http and git.
  * debian/copyright: updated the packaging copyright years.
  * debian/watch: bumped to version 4.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 20 Nov 2016 20:28:54 -0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: diskscan
 Section: utils
 Priority: optional
-Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper (>= 9),
-               cmake,
+Maintainer: Kyle Robbertze <paddatrapper@debian.org>
+Build-Depends: cmake,
+               debhelper (>= 12),
+               debhelper-compat (= 13),
                libncurses5-dev,
-               python-yaml,
+               python3-yaml,
                zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 4.6.1
 Homepage: https://github.com/baruch/diskscan
-Vcs-Git: git://anonscm.debian.org/collab-maint/diskscan.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/diskscan.git
+Vcs-Git: https://salsa.debian.org/debian/diskscan.git
+Vcs-Browser: https://salsa.debian.org/debian/diskscan
 
 Package: diskscan
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Enhances: f3
 Description: scan storage media for bad or near failure sectors
  diskscan is intended to find sectors of a storage medium

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --sourcedirectory=. --builddirectory=.

override_dh_clean:
	dh_clean
	./distclean.sh

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/diskscan-$1\.tar\.gz/ \
  https://github.com/baruch/diskscan/tags .*/v?(\d\S+)\.tar\.gz

## diskscan 0.21

=== libscsicmd/test/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,15 @@
 add_executable(scsi_log_sense scsi_log_sense.c)
 target_link_libraries(scsi_log_sense testlib scsicmd)
 
+add_executable(parse_scsi parse_scsi.c)
+target_link_libraries(parse_scsi testlib scsicmd)
+
+add_executable(scsi_mode_sense scsi_mode_sense.c)
+target_link_libraries(scsi_mode_sense testlib scsicmd)
+
+add_executable(scsi_receive_diagnostics scsi_receive_diagnostics.c)
+target_link_libraries(scsi_receive_diagnostics testlib scsicmd)
+
 add_executable(scsi_read_capacity_10 scsi_read_capacity_10.c)
 target_link_libraries(scsi_read_capacity_10 testlib scsicmd)
 
@@ -32,3 +41,6 @@
 
 add_executable(sense_decode sense_decode.c)
 target_link_libraries(sense_decode testlib scsicmd)
+
+add_executable(collect_raw_data collect_raw_data.c)
+target_link_libraries(collect_raw_data testlib scsicmd)

=== debian/changelog ===
diskscan (0.21-2) unstable; urgency=medium

  * Move to DEP-14
  * Support CMAKE 4 (Closes: #1112848)
  * Update libnurses package name

 -- Kyle Robbertze <paddatrapper@debian.org>  Tue, 04 Nov 2025 13:24:22 +0000

diskscan (0.21-1) unstable; urgency=medium

  * New upstream version 0.21
  * Bump Standards-Version to 4.6.2 (no change)

 -- Kyle Robbertze <paddatrapper@debian.org>  Sat, 16 Mar 2024 20:04:52 +0000

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: cmake,
                debhelper (>= 12),
                debhelper-compat (= 13),
-               libncurses5-dev,
+               libncurses-dev,
                python3-yaml,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/baruch/diskscan
 Vcs-Git: https://salsa.debian.org/debian/diskscan.git
 Vcs-Browser: https://salsa.debian.org/debian/diskscan

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 %:
 	dh $@ --buildsystem=cmake --sourcedirectory=. --builddirectory=.
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
+
 override_dh_clean:
 	dh_clean
 	./distclean.sh
